laser = {
	active = false,
	visible = true,
	x = 0, y = 0,
	dx = 0, dy = 0,
	draw = function()
		local tileIndex = 0
		if laser.active and laser.visible then
			if laser.dx ~= 0 then
				tileIndex = tiles.BEAM_WE
			elseif laser.dy ~= 0 then
				tileIndex = tiles.BEAM_NS
			end
			if tileIndex ~= 0 then
				tiles.images[tileIndex]:draw(laser.x * tiles.size, laser.y * tiles.size)
			end
		end
	end,
	erase = function()
		if laser.active then
			tiles.images[level.getTile(laser.x, laser.y)]:draw(laser.x * tiles.size, laser.y * tiles.size)
		end
	end,
	fire = function(x, y, dx, dy)
		if laser.active == false then
			laser.x = x
			laser.y = y
			laser.dx = dx
			laser.dy = dy
			laser.active = true
			sounds.play("laser")
		end
	end,
	update = function()
		if laser.active then
			laser.x = laser.x + laser.dx
			laser.y = laser.y + laser.dy
			if laser.x < 0 or laser.x >= level.width or laser.y < 0 or laser.y >= level.height then
				laser.active = false
			else
				local tileDefinition = tiles.definitions[level.getTile(laser.x, laser.y)]
				if tileDefinition.interact then
					tileDefinition.interact()
				else
					laser.active = false
				end
			end
		end
	end,
	reflectNWSE = function()
		local swap = laser.dx
		laser.dx = -laser.dy
		laser.dy = -swap
		laser.visible = false
		level.setTemporaryTile(laser.x, laser.y, level.getTile(laser.x, laser.y) + (tiles.MIRROR_NW_BOUNCE - tiles.MIRROR_NW))
		sounds.play("ping")
	end,
	reflectNESW = function()
		local swap = laser.dx
		laser.dx = laser.dy
		laser.dy = swap
		laser.visible = false
		level.setTemporaryTile(laser.x, laser.y, level.getTile(laser.x, laser.y) + (tiles.MIRROR_NW_BOUNCE - tiles.MIRROR_NW))
		sounds.play("ping")
	end
}