menu = {
	buttons = {
		start = {
			x = 60,
			y = 160
		},
		help = {
			x = 202,
			y = 160
		},
		about = {
			x = 60,
			y = 194
		},
		exit = {
			x = 202,
			y = 194
		}
	},
	draw = function()
		-- Draw the background.
		img = image.load("images/menu/background.png")
		img:draw(0, 0, 400, 240)
		img:close()
		
		-- Draw the logo.
		img = image.load("images/menu/logo.png")
		img:draw(60, 16)
		img:close()
		
		-- Draw the buttons.
		img = image.load("images/menu/button.png")
		for buttonName, buttonData in next, menu.buttons do
			img:draw(buttonData.x, buttonData.y)
			local buttonImg = image.load("images/menu/button-" .. buttonName .. ".png")
			buttonImg:draw(buttonData.x + math.floor((138 - buttonImg:width()) / 2), buttonData.y + 9)
			buttonImg:close()
		end
		img:close()
		
	end,
	pressButton = function(buttonName)
		local buttonData = menu.buttons[buttonName]
		img = image.load("images/menu/button-pressed.png")
		img:draw(buttonData.x, buttonData.y)
		img:close()
		img = image.load("images/menu/button-" .. buttonName .. ".png")
		img:draw(buttonData.x + math.floor((138 - img:width()) / 2) + 1, buttonData.y + 10)
		img:close()
		screen.update()
		sounds.play("clck")
	end,
	show = function()
		
		-- Draw the menu.
		menu.draw()
		screen.update()
		
		-- Wait for a button press.
		local result = nil
		while not result do
			
			-- Attempt to get input.
			if control.read() == 1 then
				if control.isButton() == 1 then
					if button.click() == 1 then
						result = "exit"
						menu.pressButton(result)
					elseif button.hold() == 1 then
						settings.show()
						menu.draw()
						screen.update()
					end
				elseif control.isTouch() == 1 then
					if touch.click() == 1 then
						x, y = touch.pos()
						for buttonName, buttonData in next, menu.buttons do
							if x >= buttonData.x and x < buttonData.x + 138 and y >= buttonData.y and y < buttonData.y + 30 then
								result = buttonName
								menu.pressButton(result)
							end
						end
					end
				end
			else
				os.sleep(10)
			end
		end
		
		os.sleep(10)
		
		return result
	end
}